import { EditorState, EditorSelection } from '@codemirror/next/state';
import { history } from '@codemirror/next/history';
import { keymap } from '@codemirror/next/keymap';
import { baseKeymap } from '@codemirror/next/commands';
import { defaultHighlighter } from '@codemirror/next/highlight';
import { csharp } from "./lang-csharp.js";
import { sendChangesToServer } from "./server/send-changes.js";
import { sendCursorToServer } from "./server/send-cursor.js";
import { slowUpdateLinter } from "./server/slow-update-linter.js";
import lineSeparator from "./line-separator.js";
export function createState(connection, options) {
  return EditorState.create({ ...(options.initialText ? {
      doc: options.initialText
    } : {}),
    ...(options.initialCursorOffset ? {
      selection: EditorSelection.single(options.initialCursorOffset)
    } : {}),
    extensions: [EditorState.indentUnit.of(4), EditorState.lineSeparator.of(lineSeparator), history(), keymap(baseKeymap), csharp(), defaultHighlighter, sendChangesToServer(connection), sendCursorToServer(connection), slowUpdateLinter(connection, options)]
  });
}